/*
 *  GOL - Game of life simulation software
 *  Copyright (C) 1996 Michael Raymond Brown
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *  Author: Michael Raymond Brown
 *  EMail:  michael@arrakeen.demon.co.uk
 *  WWW:    http://www.arrakeen.demon.co.uk/
 *  Address:  Michael Brown
 *            Kia Ora
 *            Brook Street
 *            Great Bromley
 *            Nr Colchester
 *            Essex
 *            CO7 7HX
 *            England
 */


#ifndef _tImage_h
#define _tImage_h

#ifdef __GNUC__
#pragma interface
#endif


#include "GC.h"
#include "DrawArea.h"

extern "C" {
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xos.h>
#include <X11/Xatom.h>

#ifdef HAVE_MITSHM
#include <sys/ipc.h>
#include <sys/shm.h>
#include <X11/extensions/XShm.h>
#endif
};

class xwImage : public xwGC
   {protected:
	int  width;
	int height;
	int scan_width;

	XImage*   ximage;
	Display* display;
#ifdef HAVE_MITSHM
	int	use_shm;
	XShmSegmentInfo shminfo;
#endif
	void CreateImage(xwApp* app, int format, int depth);

	xwImage();

    public:
	virtual ~xwImage();

	void plot(int x, int y, int colour);
	int point(int x, int y);

	void putImage(int src_x, int src_y, int dst_x, int dst_y, int w, int h, xwDrawArea* target);
	void putImage(int x, int y, xwDrawArea* target);

	virtual void multiPlot(int x, int y, int w, int h, const int* pixels, int scan_width) = 0;

	inline int getWidth()
	   {return width; }
	inline int getHeight()
	   {return height; }
   };

#endif

