/*
 *  GOL - Game of life simulation software
 *  Copyright (C) 1996 Michael Raymond Brown
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *  Author: Michael Raymond Brown
 *  EMail:  michael@arrakeen.demon.co.uk
 *  WWW:    http://www.arrakeen.demon.co.uk/
 *  Address:  Michael Brown
 *            Kia Ora
 *            Brook Street
 *            Great Bromley
 *            Nr Colchester
 *            Essex
 *            CO7 7HX
 *            England
 */


#ifdef __GNUC__
#pragma implementation
#endif

#include "Label.h"

xwLabel::xwLabel(xwWidget* p, const char* name, int x1, int y1, int x2, int y2)
   {XmString label = XmStringCreateLocalized((char*)name);
    parent = p;
    widget = XtVaCreateManagedWidget("label"
		, xmLabelWidgetClass, parent->getWidget()
		, XmNlabelString, label

		, XmNleftAttachment,	XmATTACH_POSITION
		, XmNrightAttachment,	XmATTACH_POSITION
		, XmNtopAttachment,	XmATTACH_POSITION
		, XmNbottomAttachment,	XmATTACH_POSITION

		, XmNleftPosition,	x1
		, XmNrightPosition,	x2
		, XmNtopPosition,	y1
		, XmNbottomPosition,	y2

		, 0);
    XmStringFree(label);

    default_callbacks(0, meth_Caption|meth_Size|meth_Close);
    linkParent(p);
   }
xwLabel::xwLabel(xwWidget* p, const char* name)
   {XmString label = XmStringCreateLocalized((char*)name);
    parent = p;
    widget = XtVaCreateManagedWidget("label"
		, xmLabelWidgetClass, parent->getWidget()
		, XmNlabelString, label
		, 0);
    XmStringFree(label);

    default_callbacks(0, meth_Caption|meth_Size|meth_Close);
    linkParent(p);
   }
xwLabel::~xwLabel()
   {
   }




